#ifndef COMMAND_H
#define COMMAND_H

#include<fstream.h>

#include"hako_io.h"
#include"info.h"
#include"value.h"

class Com;
class Land;
class Island;

class Command {
public:
    static Com *coms;
    static void alloc();
    static void initialize();
    static void jsOut();
    static void input(ifstream *);
    static void output(ofstream *);
    static void exec(Island *, int);
};

class Com {
public:
    // R}h̎
    // nn
    static const int Prepare    = 01; // n
    static const int Prepare2   = 02; // nς
    static const int Reclaim    = 03; // 
    static const int Destroy     = 04; // @
    static const int SellTree   = 05; // 
    static const int Widen      = 06; // ̓yg

    // ݌n
    static const int Plant      = 21; // A
    static const int Farm       = 22; // _ꐮ
    static const int Factory    = 23; // Hꌚ
    static const int Mountain   = 24; // ̌@ꐮ
    static const int Base       = 25; // ~TCn
    static const int DBase      = 26; // hq{݌
    static const int SBase      = 27; // Cn
    static const int Monument   = 28; // LO茚
    static const int Haribote   = 29; // n{eݒu

    // Rn
    static const int MissileNM  = 41; // ~TC
    static const int MissilePP  = 42; // PP~TC
    static const int MissileLD  = 43; // nje
    static const int MissileIS  = 44; // e~TC
    static const int Monster    = 45; // bh

    // ^cn
    static const int DoNothing  = 61; // J
    static const int Sell       = 62; // HAo
    static const int Money      = 63; // 
    static const int Food       = 64; // H
    static const int Propaganda = 65; // Uv
    static const int Giveup     = 66; // ̕
    static const int Move       = 67; // _ύX

    int getCost();
    static int getCost(int);

    // ep[^
    int kind;
    int target;
    int x;
    int y;
    int amount;
    void initialize();
    void jsOut();
    void input(ifstream *);
    void output(ofstream *);

    int exec(Island *, int);
    int buildCommand(Island *, Land *, int, int, int, int, int,
		     int, int, int, int, int, int);
    inline void log(int, int, int, int, 
		    int = 0, int = 0, int = 0, int = 0, int = 0);
};

#endif
