#ifndef MAP_H
#define MAP_H

#include<fstream.h>
#include<stdio.h>

#include"util.h"
#include"value.h"
#include"hako_io.h"
#include"monster.h"

class Island;

struct Point {
    int x;
    int y;
};

class Land;

class Map {
public:
    static Land *land;

    // ̈m
    static void alloc();

    // 
    static void initialize();

    // t@Co
    static void output(ofstream *);

    // t@C
    static void input(ifstream *);

    // JavaScripto
    static void jsOut(int);

    // ӂ̍WԂ
    static Point getPoint(int, int, int);

    // wWLand̃|C^Ԃ
    static Land *getLand(int, int);

    // wWLand̃|C^Ԃ(Point)
    inline static Land *getLand(Point p) {
	return getLand(p.x, p.y);
    }

    // wW̎ӂLand̃|C^Ԃ
    static Land *getAround(int, int, int);

    // wW̎ӂLand̃|C^Ԃ(Point)
    inline static Land *getAround(Point p, int n) {
	return getAround(p.x, p.y, n);
    }

    // wWӂŁA̎ނ̓yn𐔂
    static int countAround(int, int, int, int, int, int = -1);

    // wWӂŁA̎ނ̓yn𐔂(Point)
    inline static int countAround(Point p, int kind, int from,
				  int to, int param = -1) {
	return countAround(p.x, p.y, kind, from, to, param);
    }

    // wWӂŁAnт𐔂
    static int countNeutral(int, int, int, int);

    // wWӂŁA̓ynn邩ǂ
    static int nearLand(int, int, int, int, int id);

    // wWӂŁA̓ynnrnȊO邩ǂ
    static int nearLand2(int, int, int, int, int id);

    // CۓxvZ
    static void calcSea(int, int);

    // ̓ẙ
    static void infLand(int, int);

    // wWɂwbNX
    static void process(int, int);

    // S̍ЊQ
    static void globalDisaster();

    // l̑𐔂
    static void estimate();

    // nk
    static void disEarthquake(int, int);

    // Ôg
    static void disTsunami(int, int);

    // 䕗
    static void disTyphoon(int, int);

    // Q
    static void disMeteo(int, int);

    // 
    static void disEruption(int, int);

    // b
    static void disMonster(Land *, int, int, int);

    // ΍Д
    static int disFire(Land *, int, int, int, int);

    // H\
    static int disRiot(Land *, int, int, int, int);

    // 
    static void getBoatPeople(Island *);

    // LQ
    static void wideDamage(int, int);

    // ̏
    static void deleteIslands(int *);

    // yn̎XV
    static void changeOwner(int *);

    // vZ
    static int distance(int, int, int, int);

    // Oo
    inline static void log(int, int, int, int, int = 0,
			   int = 0, int = 0, int = 0, int = 0);
};

class Land {
public:
    // n`̎
    static const int Sea      = 0x0;
    static const int Waste    = 0x1;
    static const int Town     = 0x2;
    static const int Forest   = 0x3;
    static const int Farm     = 0x4;
    static const int Factory  = 0x5;
    static const int Base     = 0x6;
    static const int DBase    = 0x7;
    static const int Mountain = 0x8;
    static const int Monster  = 0x9;
    static const int SBase    = 0xa;
    static const int Monument = 0xb;

    // n`̃p[^
    // C
    static const int SeaDeep  = 0x0;
    static const int SeaShoal = 0x1;
    static const int SeaOil   = 0x2;

    // rn
    static const int WasteNormal  = 0x0;
    static const int WasteMissile = 0x1;

    // hq{
    static const int DBaseTrue  = 0x0;
    static const int DBaseFalse = 0x1;

    // Cۓx
    static const int SeaLevel1 = 12;
    static const int SeaLevel2 = 24;


    unsigned char kind;  // 
    unsigned char param; // p[^
    unsigned char owner; // ǂ̗̒n

    // tO(NuȂ)
    unsigned char flag;

    // Cۓx
    unsigned char seaLevel;

    // 
    void initialize();

    // t@Co
    void output(ofstream *);

    // t@Cl
    void input(ifstream *);

    // JavaScripto
    void jsOut(int);

    // l̑𐔂
    void estimate();

    // Op̓ynԍ߂
    int landValue();

    // yn̎XV
    void changeOwner(int *);

    // x߂
    int getLevel();
};

#endif
